package org.jeecg.modules.demo.linkouterchainlog.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.demo.linkouterchainlog.entity.LinkOuterChainLog;
import org.jeecg.modules.demo.linkouterchainlog.service.ILinkOuterChainLogService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.demo.mainsite.entity.MainSite;
import org.jeecg.modules.demo.mainsite.service.IMainSiteService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 外链检测日志信息
 * @Author: jeecg-boot
 * @Date:   2023-04-13
 * @Version: V1.0
 */
@Api(tags="外链检测日志信息")
@RestController
@RequestMapping("/linkouterchainlog/linkOuterChainLog")
@Slf4j
public class LinkOuterChainLogController extends JeecgController<LinkOuterChainLog, ILinkOuterChainLogService> {
	@Autowired
	private ILinkOuterChainLogService linkOuterChainLogService;
	 @Autowired
	 private IMainSiteService iMainSiteService;
	/**
	 * 分页列表查询
	 *
	 * @param linkOuterChainLog
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "外链检测日志信息-分页列表查询")
	@ApiOperation(value="外链检测日志信息-分页列表查询", notes="外链检测日志信息-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<LinkOuterChainLog>> queryPageList(LinkOuterChainLog linkOuterChainLog,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<LinkOuterChainLog> queryWrapper = QueryGenerator.initQueryWrapper(linkOuterChainLog, req.getParameterMap());
		Page<LinkOuterChainLog> page = new Page<LinkOuterChainLog>(pageNo, pageSize);
		IPage<LinkOuterChainLog> pageList = linkOuterChainLogService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param linkOuterChainLog
	 * @return
	 */
	@AutoLog(value = "外链检测日志信息-添加")
	@ApiOperation(value="外链检测日志信息-添加", notes="外链检测日志信息-添加")
	@RequiresPermissions("linkouterchainlog:link_outer_chain_log:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody LinkOuterChainLog linkOuterChainLog) {

		try {
			String mainSiteId = linkOuterChainLog.getMainSiteId();
			MainSite mainSite = iMainSiteService.getById(mainSiteId);
			linkOuterChainLog.setMainSiteName(mainSite.getMainSiteName());
			linkOuterChainLog.setMainSiteUrl(mainSite.getMainSiteUrl());
		}catch (Exception e){
			e.printStackTrace();
		}

		linkOuterChainLogService.save(linkOuterChainLog);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param linkOuterChainLog
	 * @return
	 */
	@AutoLog(value = "外链检测日志信息-编辑")
	@ApiOperation(value="外链检测日志信息-编辑", notes="外链检测日志信息-编辑")
	@RequiresPermissions("linkouterchainlog:link_outer_chain_log:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody LinkOuterChainLog linkOuterChainLog) {
		try {
			String mainSiteId = linkOuterChainLog.getMainSiteId();
			MainSite mainSite = iMainSiteService.getById(mainSiteId);
			linkOuterChainLog.setMainSiteName(mainSite.getMainSiteName());
			linkOuterChainLog.setMainSiteUrl(mainSite.getMainSiteUrl());
		}catch (Exception e){
			e.printStackTrace();
		}
		linkOuterChainLogService.updateById(linkOuterChainLog);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "外链检测日志信息-通过id删除")
	@ApiOperation(value="外链检测日志信息-通过id删除", notes="外链检测日志信息-通过id删除")
	@RequiresPermissions("linkouterchainlog:link_outer_chain_log:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		linkOuterChainLogService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "外链检测日志信息-批量删除")
	@ApiOperation(value="外链检测日志信息-批量删除", notes="外链检测日志信息-批量删除")
	@RequiresPermissions("linkouterchainlog:link_outer_chain_log:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.linkOuterChainLogService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "外链检测日志信息-通过id查询")
	@ApiOperation(value="外链检测日志信息-通过id查询", notes="外链检测日志信息-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<LinkOuterChainLog> queryById(@RequestParam(name="id",required=true) String id) {
		LinkOuterChainLog linkOuterChainLog = linkOuterChainLogService.getById(id);
		if(linkOuterChainLog==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(linkOuterChainLog);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param linkOuterChainLog
    */
    @RequiresPermissions("linkouterchainlog:link_outer_chain_log:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, LinkOuterChainLog linkOuterChainLog) {
        return super.exportXls(request, linkOuterChainLog, LinkOuterChainLog.class, "外链检测日志信息");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("linkouterchainlog:link_outer_chain_log:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, LinkOuterChainLog.class);
    }

}
